///home/berryj/link/bin/genMethods "-t" "Testobj*" "-h" "SortedList" "-r" "List<Testobj*>" "-I" "LINK/basic/SortedList.h" "-I" "LINK/userobj/Testobj.h" "-d" "userobj" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SortedList.h>

#include <LINK/userobj/Testobj.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Testobj* _Testobj_;
typedef SortedList<Testobj* > _SortedList_Testobj__;
static SortedList<Testobj* > s__SortedList_Testobj__;

#define _SortedList_Testobj__DATA(x) ((SortedList<Testobj* >*) (EXTDATA(x)))
#define _SortedList_Testobj__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<Testobj* > >::type))
#define _SortedList_Testobj__ISNT_DATA(x) (!_SortedList_Testobj__IS_DATA(x))

#define _SortedList_Testobj__CXX_DATA(x) (*(SortedList<Testobj* >*) (EXTDATA(VAL(x))))
#define _SortedList_Testobj__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedList<Testobj* > >::type))
#define _SortedList_Testobj__CXX_ISNT_DATA(x) (!_SortedList_Testobj__CXX_IS_DATA(x))


PRIMITIVE STk_init__SortedList_Testobj__()
{
	Wrapper<_SortedList_Testobj__>::type = STk_new_CXXwrapper_id(
			Wrapper<_SortedList_Testobj__>::name, 
			Wrapper<List<Testobj*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Testobj_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Testobj_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Testobj_>::freeTypedList);
	Tcl_InitHashTable(&Register<_SortedList_Testobj__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_SortedList_Testobj__Methods(void);

PRIMITIVE STk_init_methods__SortedList_Testobj__()
{
	genExtra_SortedList_Testobj__Methods();
	return UNDEFINED;
}
